/*****************************************************************************
*                                                                            *
*        FHK 1.0 - 27/5/1992 Copyright (c) Marco Savegnago IW3FQG            *
*                                                                            *
*        Find out HotKey combination for use with TSR programs               *
*                                                                            *
*        This program is part of IW3FQG's FOOT (FQG Own Original Tools)      *
*                                                                            *
*        Use Turbo or Borland C++ complier to compile it.                    *
*                                                                            *
*****************************************************************************/

#include <dos.h>
#include <stdio.h>
#include <string.h>

#define YES 1
#define NO  0


void    interrupt my_int9(...);
void    interrupt (*old_int9)(...);
int     isAny(void);
char *  print_shift (char code);
char *  print_key (char code);


struct Key_table
{
        char chr;
        char *letter;
};

static Key_table key_tbl[] =
{
        { 0x01, "Esc" },
	{ 0x02, "1" },
	{ 0x03, "2" },
	{ 0x04, "3" },
	{ 0x05, "4" },
	{ 0x06, "5" },
	{ 0x07, "6" },
	{ 0x08, "7" },
	{ 0x09, "8" },
	{ 0x0A, "9" },
	{ 0x0B, "0" },
	{ 0x0C, "-" },
	{ 0x0D, "=" },
	{ 0x0E, "BackSpace" },
	{ 0x0F, "Tab"},
	{ 0x10, "Q" },
	{ 0x11, "W" },
	{ 0x12, "E" },
	{ 0x13, "R" },
	{ 0x14, "T" },
	{ 0x15, "Y" },
	{ 0x16, "U" },
	{ 0x17, "I" },
	{ 0x18, "O" },
	{ 0x19, "P" },
	{ 0x1A, "[" },
	{ 0x1B, "]" },
	{ 0x1C, "Enter"},
        { 0x1D, "Control"},
	{ 0x1E, "A" },
	{ 0x1F, "S" },
	{ 0x20, "D" },
	{ 0x21, "F" },
	{ 0x22, "G" },
	{ 0x23, "H" },
	{ 0x24, "J" },
	{ 0x25, "K" },
	{ 0x26, "L" },
	{ 0x27, ";" },
	{ 0x28, "'" },
	{ 0x29, "`" },
        { 0x2A, "LShift"},
        { 0x2B, "\\"},
	{ 0x2C, "Z" },
	{ 0x2D, "X" },
	{ 0x2E, "C" },
	{ 0x2F, "V" },
	{ 0x30, "B" },
	{ 0x31, "N" },
	{ 0x32, "M" },
	{ 0x33, "," },
	{ 0x34, "." },
	{ 0x35, "/" },
        { 0x36, "LShift"},
	{ 0x37, "Grey *" },
        { 0x38, "Alt"},
        { 0x39, "Space"},
        { 0x3A, "CapsLock"},
	{ 0x3B, "F1" },
	{ 0x3C, "F2" },
	{ 0x3D, "F3" },
	{ 0x3E, "F4" },
	{ 0x3F, "F5" },
	{ 0x40, "F6" },
	{ 0x41, "F7" },
	{ 0x42, "F8" },
	{ 0x43, "F9" },
	{ 0x44, "F10" },
        { 0x45, "NumLock"},
        { 0x46, "ScrollLock"},
	{ 0x47, "Home" },
	{ 0x48, "Up" },
	{ 0x49, "PgUp" },
	{ 0x4A, "Grey -" },
	{ 0x4B, "Left" },
	{ 0x4C, "Grey 5" },
	{ 0x4D, "Right" },
	{ 0x4E, "Grey +" },
	{ 0x4F, "End" },
	{ 0x50, "Down" },
	{ 0x51, "PgDn" },
	{ 0x52, "Ins" },
	{ 0x53, "Del" },

	{ 0x57, "F11" },
	{ 0x58, "F12" },

	{ 0x00, NULL }
};

struct Shift_table
{
        char chr;
        char *letter;
};

Shift_table shift_tbl[] =
{
        { 0x01, "RSHIFT" },
        { 0x02, "LSHIFT" },
        { 0x04, "CTRL" },
        { 0x08, "ALT" },
        { 0x00, NULL }
};

static Shift_table * shift_ptr;
static Key_table * key_ptr;

static char temp[30], bios_extended=NO;
volatile unsigned char reset = NO, scancode = 0, shift = 0;



char * print_shift (char code)
{
	strcpy(temp,"");

	shift_ptr=shift_tbl;

	while(shift_ptr->chr)
	{
		if (code & shift_ptr->chr)
		{
			strcat(temp,shift_ptr->letter);
			strcat(temp,"-");
		}
		shift_ptr++;
	}
	return(temp);
}


char * print_key (char code)
{
	key_ptr=key_tbl;

	while(key_ptr->chr)
	{
		if (code == key_ptr->chr)
			return(key_ptr->letter);

		key_ptr++;
	}
	return(NULL);
}


void interrupt my_int9(...)
{
        unsigned char far *shift = (unsigned char far *) 0x00000417L;
        char scancode=inportb(0x60);

        // if the user hits CTRL-ALT-DEL !!!!!!

        if(*shift & 0x04 && *shift & 0x08 && scancode == 0x53)
        {
                reset = YES;           // Intercept and avoid reset!
                outportb(0x20, 0x20);  // Send EOI to PIC
        }
        else
        {
                ::scancode=scancode;

        //      This strip the four high bit of shiftstate because SendPass,
        //      check only for the first four shift key.
        //      If you want to get the full shiftstate (complete of caps, num
        //      and scroll lock) you can remove the stripper code and add the
        //      code to Shift_table structure.

                ::shift=*shift & 0x0f;
                old_int9();
        }
}

// isAny is the same of kbhit() but avoid CTRL-C problem

int isAny(void)
{
        asm    mov al,1
        asm    add al,bios_extended
        asm    mov ah,al
        asm    int 16h
        asm    mov ax,0
        asm    jz NoCh
        asm    not ax
NoCh:
        return (_AX);
}

void main(void)
{
        old_int9 = getvect(9);
        setvect(9, my_int9);

        // Check if extended BIOS is present

        asm     mov     ax,11ffh
        asm     int     16h
        asm     cmp     ax,11ffh
        asm     je      not_extended
        asm     mov     bios_extended,10h

not_extended:

        puts("FHK 1.0 - 27/5/1992 Copyright (c) Marco Savegnago IW3FQG\n\n"
             "Find out HotKey combination for use with TSR programs.\n"
             "Press CTRL-ALT-DEL to terminate program!\n\n");

        while(!reset)
        {
                while(!reset && !isAny())
                ; // NOOP

                if(reset)
                        puts("\nCiao!\n");
                else
                {
                        asm    mov ah,bios_extended
                        asm    int 16h
                        for (int i=0;i<79;i++)
                                        putchar(' ');

                        printf("\rHotKey:  %s%s  Shiftstate:  %02x Scancode:  %02x\r",print_shift(shift),print_key(scancode),shift,scancode);
                }
        }
        setvect(9, old_int9);
}

